
# Before including this Makefile.inc the following vars can be set:
#    sources   - *.c, *.cc, *.y, *.l
#    cflags    - additional CFLAGS
#    release   - version of prog={release, profile, debug}
# The following MUST be set:
#    root      - directory where this Makefile.inc lies

############################################################################

CC=g++
cflags = -DSTATISTICS
cflags += -DNDEBUG
CFLAGS=-Wall -I$(root) $(cflags) -DVERSION=$(VERSION_STR)  $(ADDCFLAGS) 


DEPS=.depend
CDEPSFLAGS=-MM -MG
AR=ar qc
LD=ld -r 
LIBNAME=lib.o


##############################################################################

.PHONY: $(subdirs)

ifndef prog
lib:=$(LIBNAME)
endif

# We will remake *.c, *.cc
objects:=$(sources:%.c=%)
objects:=$(objects:%.cc=%)

# Libraries are taken from the subdirs
subdirlibs:=$(subdirs:%=%/$(LIBNAME))

# C/C++ sources
csources=$(filter %.c %.cc,$(sources))

default: $(release)

debug:
	$(MAKE) all ADDCFLAGS="-DDEBUG -g"

profile:
	$(MAKE) all ADDCFLAGS="-pg -g -DPROFILE"
	
release:
	$(MAKE) all ADDCFLAGS="-O3"

all: $(objects)

%: %.cc
	$(CC) $(CFLAGS) $< -o $@

%: %.c
	$(CC) $(CFLAGS) $< -o $@ 

clean:
	rm -f $(objects) $(prog) $(DEPS)
